
import { SGraphItem } from "@saga-web/graph/lib";
import { SPoint } from "@saga-web/draw/lib";
import { SLineItem } from '@saga-web/big/lib';
import { Marker } from '../types/Marker';

/**
 * 标识对象Item(线类型)
 *
 * * @author  张宇(taohuzy@163.com)
 */
export class SLineMarkerItem extends SLineItem {
    /** 标识对象数据 */
    data: Marker;

    set width(v: number) {
        if (this.data.Size) {
            this.data.Size.Width = v;
        }
    }

    set height(v: number) {
        if (this.data.Size) {
            this.data.Size.Height = v;
        }
    }

    /**
     * 构造函数
     *
     * @param parent    指向父对象
     * @param data      标识对象数据
     */
    constructor(parent: SGraphItem | null, data: Marker) {
        super(parent,[]);
        this.data = data;
        this.id = data.ID;
        this.name = data.Name;
        this.moveTo(data.Pos.X, data.Pos.Y);
        if (data.Size) {
            this.width = data.Size.Width;
            this.height = data.Size.Height;
        }
        if (data.Properties && data.Properties.Line) {
            this.line = data.Properties.Line;
        }
    } // Constructor
    
} // Class SLineMarkerItem
